#include <stdio.h> /* RTK 2008.3.2 */
#include <stdbool.h>

#define MaxW 3000
#define MaxH 3000

typedef enum { Gor, Levo, Dol, Desno, Prazna, Pregledana, Neobiskana } CelicaT;
typedef enum { Nic, Yusuf, Muhammad } KdoT;
const int DX[4] = { 0, -1, 0, 1 };
const int DY[4] = { -1, 0, 1, 0 };
CelicaT a[MaxH + 2][MaxW + 2];

int main(int argc, char **argv)
{
	FILE *f; char c; KdoT poddrevo; bool prvic; CelicaT d, dNasl;
	int w, h, x, y, xx, yy, yKoren, xRazcep, stopnja, stMest[3];

	/* Preberimo vhodne podatke. */
	f = fopen(argc > 1 ? argv[1] : "berberi.in", "rt");
	fscanf(f, "%d %d\n", &w, &h);
	for (x = 1; x <= w; x++) { a[0][x] = Prazna; a[h + 1][x] = Prazna; }
	for (y = 1; y <= h; y++) { a[y][0] = Prazna; a[y][w + 1] = Prazna; }
	yKoren = -1; xRazcep = -1;
	for (y = 1; y <= h; y++) {
		for (x = 1; x <= w; x++) {
			c = (char) fgetc(f); a[y][x] = (c == '.') ? Prazna : Neobiskana;
			if (x == 1 && c == 'X') yKoren = y; }
		c = (char) fgetc(f); }
	fclose(f);

	/* Preglejmo drevo. */
	stMest[Yusuf] = 0; stMest[Muhammad] = 0; poddrevo = Nic;
	x = 1; y = yKoren; a[y][x] = Desno;
	while (a[y][x] != Prazna)
	{
		/* Doloimo stopnjo trenutne toke in poiimo kaknega
		   e neobiskanega otroka. */
		stopnja = 0; dNasl = Prazna; prvic = true;
		for (d = Gor; d <= Desno; d++)
		{
			xx = x + DX[d]; yy = y + DY[d];
			if (a[yy][xx] != Pregledana && a[yy][xx] != Neobiskana) continue;
			stopnja++;
			if (a[yy][xx] == Neobiskana) dNasl = d;
			else prvic = false;
		}
		if (stopnja == 0) /* Smo v listu. */
			stMest[poddrevo]++;
		else if (stopnja > 1) { /* Smo v razvejiu. */
			if (poddrevo == Nic) xRazcep = x; /* Mesto prvega spora med Yusufom in Muhammadom. */
			else if (prvic) stMest[poddrevo]++; }
		if (dNasl != Prazna) { /* Spustimo se naprej po drevesu. */
			if (x == xRazcep && y == yKoren) /* Zapomnimo si, v katero poddrevo gremo zdaj. */
				poddrevo = (dNasl == Dol) ? Muhammad : Yusuf;
			x += DX[dNasl]; y += DY[dNasl];
			a[y][x] = dNasl; }
		else { /* Vrnimo se nazaj v oeta trenutne toke. */
			d = a[y][x]; a[y][x] = Pregledana;
			if (x == xRazcep && y == yKoren) poddrevo = Nic;
			x -= DX[d]; y -= DY[d]; }
	}

	/* Izpiimo rezultat. */
	f = fopen(argc > 2 ? argv[2] : "berberi.out", "wt");
	fprintf(f, "%d %d\n", stMest[Yusuf], stMest[Muhammad]); fclose(f); return 0;
}
